import java.security.SecureRandom;
import java.io.IOException;
import java.nio.file.Paths;
import java.nio.file.Files;
import java.util.List;

public class Passgen {
    private static SecureRandom random;


    public String generate_simple_password(int count) {
        random = new SecureRandom();
        String simpleCharacters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
        String password = "";
        int randomIndex;
        char randomChar;
        for (int i = 0; i < count; i++) {
            randomIndex = random.nextInt(simpleCharacters.length());
            randomChar = simpleCharacters.charAt(randomIndex);
            password = password + randomChar;
        }
        return password;
    }

    public String generate_regular_password(int count) {
        random = new SecureRandom();
        String characters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!@#$%^&*";
        String password = "";
        int randomIndex;
        char randomChar;
        for (int i = 0; i < count; i++) {
            randomIndex = random.nextInt(characters.length());
            randomChar = characters.charAt(randomIndex);
            password = password + randomChar;
        }
        return password;
    }

    public String generate_xkcd_password(int count) {
        random = new SecureRandom();
            String password = "";
        try {
            List<String> dictionary = Files.readAllLines(Paths.get("/usr/share/dict/words"));

            int randomIndex;
            String randomWord;
            for (int i = 0; i < count; i++) {
                randomIndex = random.nextInt(dictionary.size());
                randomWord = dictionary.get(randomIndex);
                password = password + randomWord;
                password = password + " ";
            }
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("An error occured while reading /usr/share/dict/words - Is the file present?");
            System.exit(2);
        }
        return password;
    }

}
