import java.util.Map;

interface Weapon {
    Dice dice = new Dice();
    // Retrieve the to-hit-bonus every time
    int getHitBonus(int bonus);
    // get the damage Bonus every time
    int getDamageBonus(int bonus);
    // get the weapon's range every time
    int getRange(int range);
    // Have the weapon roll for damange every
    default int rollToHit(int bonus) {
        int diceResult = dice.rollD20();
        switch (diceResult) {
            case 1:
                return 0;
            case 20:
                return 100;
            default:
                return diceResult + bonus;
        }
    }
    // Have the weapon role for damage
    int rollDamage(int bonus);
}

abstract class Sword implements Weapon {
    Map<String, Integer> requirements;
    String infoDamageDice;
    String infoDamageBonus;
    int playerStrength;
    String type = "Melee";
    String name;
    String rarity;
    int range;
    int hitBonus;
    int damageBonus;

    @Override
    public int getRange(int range){
        return range;
    }
    public int getRange() {
        return getRange(5);
    }
    @Override
    public int getHitBonus(int bonus) {
        return bonus;
    }
    public int getHitBonus(){
        return getHitBonus(0);
    }
    @Override
    public int getDamageBonus(int bonus) {
        return bonus;
    }
    public int getDamageBonus(){
        return getHitBonus(0);
    }
}

abstract class Bow implements Weapon {
    Map<String, Integer> requirements;
    String infoDamageDice;
    String infoDamageBonus;
    int playerStrength;
    int playerDex;
    String type = "Ranged";
    String name;
    String rarity;
    int range;
    int hitBonus;
    int damageBonus;
    @Override
    public int getRange(int range){
        return range;
    }
    public int getRange() {
        return getRange(300);
    }
    @Override
    public int getHitBonus(int bonus) {
        return bonus;
    }
    public int getHitBonus(){
        return getHitBonus(0);
    }
    @Override
    public int getDamageBonus(int bonus) {
        return bonus;
    }
    public int getDamageBonus(){
        return getHitBonus(0);
    }
}
