import java.util.HashMap;

class Longbow extends Bow {
    public Longbow(int distance, int strength, int dex) {
        requirements = new HashMap<>();
        requirements.put("Dex", 14);
        requirements.put("Str", 8);
        playerStrength = strength;
        playerDex = dex;
        infoDamageBonus = "0-2";
        name = "Longbow";
        rarity = "Common";
        range = getRange(500);
        hitBonus = getHitBonus();
        damageBonus = getDamageBonus(distance);
    }

    @Override
    public int getDamageBonus(int distance) {
        if (playerDex < requirements.get("Dex") || playerStrength < requirements.get("Str")) {
            return -20;
        }

        if (distance > 20 && distance <= 165) {
            return 2;
        }
        else if (distance > 165 && distance <= 300) {
            return 1;
        }
        else {
            return 0;
        }
    }

    @Override
    public int rollToHit(int bonus) {
            return dice.rollD20();
    }

    @Override
    public int rollDamage(int bonus) {
        int dieResult = dice.rollD10();
        if (dieResult + bonus < 0) {
            return 0;
        } else {
            return dieResult + bonus;
        }
    }
}

class Shortbow extends Bow {
    public Shortbow(int strength, int dex) {
        requirements = new HashMap<>();
        requirements.put("Dex", 8);
        requirements.put("Str", 6);
        infoDamageBonus = "0";
        playerStrength = strength;
        playerDex = dex;
        name = "Shortbow";
        rarity = "Common";
        range = getRange();
        hitBonus = getHitBonus();
        damageBonus = getDamageBonus();
    }
    @Override
    public int getDamageBonus() {
        if (playerDex < requirements.get("Dex") || playerStrength < requirements.get("Str")) {
            return -20;
        } else {
            return 0;
        }

    }

    public int rollDamage(int bonus){
        int dieResult = dice.rollD6();
        if (dieResult + bonus < 0) {
            return 0;
        } else {
            return dieResult;
        }
    }
}
